LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER NPARMS
C                                       NPARMS=no. adverbs passed.
C USERID     User number.
C INNAME     Main input file (name).
C INCLASS    Main input file (class).
C INSEQ      Main input file (seq. #).
C INDISK     Disk unit #.       0 => any
C INVERS     Input  file version no.
C
      PARAMETER (NPARMS=6)
      INTEGER AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END

LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
C                                       Adverb names
C                      1        2         3          4        5
      DATA AVNAME /'USERID', 'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
C           6
     *   'INVER'/
C                                       Adverb data types (PAOOF.INC)
C                      1        2         3          4        5
      DATA AVTYPE /  OOAINT,  OOACAR,   OOACAR,    OOAINT,  OOAINT,
C           6
     *    OOAINT/
C                                       Adverb dimensions (as 2D)
C                      1        2         3          4        5
      DATA AVDIM /   1,1,    12,1,      6,1,       1,1,     1,1,
C           6
     *    1,1/
LOCAL END

      PROGRAM ANNAB
C-----------------------------------------------------------------------
C! Change map scale to correct for annual aberration
C# Utility OOP
C   This software is the subject of a User agreement and is confidential
C   in nature. It shall not be sold or otherwise made available or
C   disclosed to third parties.
C-----------------------------------------------------------------------
      INTEGER  IERR, BUFF1(256)
      INTEGER NHIST, NHMAX
      PARAMETER (NHMAX = 20)
      CHARACTER PRGM*6, INOBJ*32, OUTOBJ*32, MYHIST(NHMAX)*72
      DATA PRGM /'ANNAB '/, NHIST /0/
C-----------------------------------------------------------------------
C                                       Startup
      CALL ANABIN (PRGM, INOBJ, OUTOBJ, IERR)
C                                       Do action
      IF (IERR.EQ.0) CALL ANABAB (INOBJ, OUTOBJ, MYHIST, NHMAX,
     *   NHIST, IERR)
C                                       History
      IF (IERR.EQ.0) CALL ANABHI (OUTOBJ, MYHIST, NHIST)
C                                       Close down files, etc.
 990  CALL DIE (IERR, BUFF1)
C
 999  STOP
      END

      SUBROUTINE ANABIN (PRGN, INOBJ, OUTOBJ, IERR)
C-----------------------------------------------------------------------
C   ANABIN gets input parameters for ANNAB and creates the input and
C   output object.
C
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      INOBJ   C*32 Input object name
C      OUTOBJ  C*32 Output object name
C      IERR    I    Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER PRGN*6, INOBJ*32, OUTOBJ*32
C
      INTEGER   NKEY1
C                                       NKEY1=no. adverbs to copy to INOBJ
      PARAMETER (NKEY1=6)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs to copy to INOBJ
C                      1        2         3          4        5
      DATA INK1   /'USERID', 'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
C           6
     *   'INVER'/
C                                       May rename adverbs to INOBJ
C                      1        2         3          4        5
      DATA OUTK1  /'USERID', 'NAME',   'CLASS',   'IMSEQ',   'DISK',
C           6
     *   'VER'/
C
C-----------------------------------------------------------------------
C                                       Startup,  returns "Input" object
C                                       containing POPS adverbs
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Create input object
      INOBJ = 'Input object'
      CALL CREATE (INOBJ, 'IMAGE', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, INOBJ, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Shallow copy image for write
      OUTOBJ = 'Shallow copy'
      CALL OCOPY (INOBJ, OUTOBJ, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END

      SUBROUTINE ANABHI (OUTOBJ, MYHIST, NHIST)
C-----------------------------------------------------------------------
C   Routine to write history file to output object.  This assumes
C   that a previous history exists and merely adds the information from
C   the current task.
C
C   If NHIST=0 then no history records are written.
C
C   Inputs:
C      OUTOBJ  C*?  Output object
C      MYHIST  C*72 Array (NHIST) of extra history lines
C-----------------------------------------------------------------------
      INTEGER NHIST
      CHARACTER OUTOBJ*(*), MYHIST(NHIST)*72
C
      INTEGER   NADV, I
      PARAMETER (NADV=4)
      CHARACTER LIST(NADV)*8
      INTEGER   IERR
      INCLUDE 'INCS:DMSG.INC'
C                                       Adverbs to copy to history
      DATA LIST /'INNAME', 'INCLASS', 'INSEQ', 'INVER'/
C-----------------------------------------------------------------------
C
      IF (NHIST.EQ.0) RETURN
C                                       Add task label to history
      CALL OHTIME (OUTOBJ, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Copy adverb values.
      CALL OHLIST ('Input', LIST, NADV, OUTOBJ, IERR)
      IF (IERR.NE.0) GO TO 990
C
C                                       Add info on results.
      DO 10 I=1,NHIST
         CALL OHWRIT(MYHIST(I), OUTOBJ, IERR)
         IF (IERR.NE.0) GO TO 990
  10  CONTINUE
C
      CALL OCLOSE (OUTOBJ, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // OUTOBJ
      CALL MSGWRT (4)
 999  RETURN
      END

      SUBROUTINE ANABAB (INOBJ, OUTOBJ, MYHIST, NHMAX, NHIST, IERR)
C-----------------------------------------------------------------------
C   Convert annual aberration scale change and modify pixel
C   size in header.
C   Inputs:
C      INOBJ   C*   Name of input object.
C      NHMAX   I    Maximum number of history lines to write.
C   Output:
C      MYHIST  C*72 History lines.
C      NHIST   I    Number of history lines written.
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   NHMAX, NHIST, IERR
      CHARACTER INOBJ*(*), OUTOBJ*(*), MYHIST(NHMAX)*72
C
C
      INTEGER   TYPE, DIM(7), DIM2(7), I, MSGSAV, KILSAV
      REAL XSHIFT, YSHIFT, JEPOCH, SCALE, VLRNTZ, CDELT(7)
      DOUBLE PRECISION RACEN, DECEN, RA2000, DC2000
C
      INTEGER          EQUINX
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Open input & output objects
      CALL OOPEN (INOBJ, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OOPEN (OUTOBJ, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Make new header keywords
      CALL OBVHKW ('IMAGE   ', 'ANNABCOR', OOALOG, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBVHKW ('IMAGE   ', 'ANNABCD1', OOARE, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBVHKW ('IMAGE   ', 'ANNABCD2', OOARE, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Check whether correction already done
C                                       Suppress warning messages.
      MSGSAV = MSGSUP
      KILSAV = MSGKIL
      MSGSUP = 32000
      MSGKIL = 32007
      CALL OGET (INOBJ, 'ANNABCOR', TYPE, DIM, I, I, IERR)
      MSGSUP = MSGSAV
      MSGKIL = KILSAV
      IF (IERR.NE.0) THEN
C                                       Assume that correction has not been done
         IERR = 0
      ELSE IF (TYPE .NE. OOALOG) THEN
C                                       Keyword is present but is not logical!
         WRITE (MSGTXT, 1001)
     *      'Keyword ANNABCOR is not of type logical!'
         CALL MSGWRT (4)
         IERR = 1
         GO TO 999
      ELSE IF (I .NE. 0) THEN
C
C                                       Correction was already done
         WRITE (MSGTXT, 1001)
     *      'Warning: ANNABCOR=T, correction not applied twice'
         CALL MSGWRT (1)
C                                       Close input image
         CALL OCLOSE (INOBJ, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Close output image
         CALL OCLOSE (OUTOBJ, IERR)
         IF (IERR.NE.0) GO TO 999
         GO TO 999
      ENDIF
C
C                                       Get position, equinox, & epoch
      CALL GETPOS (INOBJ, RACEN, DECEN, XSHIFT, YSHIFT, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GETEQN (INOBJ, EQUINX, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL GETEPC (INOBJ, JEPOCH, IERR)
      IF (IERR.NE.0) GO TO 999
C
C                                       Convert RACEN, DECEN to J2000
      RA2000 = RACEN
      DC2000 = DECEN
      IF (EQUINX.NE.2000) THEN
         CALL PRECSS(RA2000,DC2000,EQUINX,2000,IERR)
         IF (IERR.NE.0) GO TO 999
      ENDIF
C
      WRITE (MSGTXT, 1004) 'Epoch of observation = ',JEPOCH
      CALL MSGWRT (1)
      WRITE (MSGTXT, 1004) 'RA = ', RA2000, ' (2000) Dec = ', DC2000
      CALL MSGWRT (1)
C
C                                       Get scale change
      SCALE = VLRNTZ (RA2000, DC2000, JEPOCH)
C
C                                       Get old pixel sizes
      CALL OGET (INOBJ, 'IMAGE_DESC.CDELT', TYPE, DIM, CDELT, CDELT,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
      WRITE(MSGTXT,1003) 'before ', 3600*CDELT(1), 3600*CDELT(2)
      CALL MSGWRT (1)
C
C                                       Save old pixel sizes
      DIM2(1) = 1
      DIM2(2) = 0
      CALL OPUT (OUTOBJ, 'ANNABCD1', OOARE, DIM2, CDELT(1), CDELT(1),
     *   IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OPUT (OUTOBJ, 'ANNABCD2', OOARE, DIM2, CDELT(2), CDELT(2),
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C
C                                       Change pixel sizes
      CDELT(1) = CDELT(1)*SCALE
      CDELT(2) = CDELT(2)*SCALE
      WRITE(MSGTXT,1003) 'after  ', 3600*CDELT(1), 3600*CDELT(2)
      CALL MSGWRT (1)
      CALL OPUT (OUTOBJ, 'IMAGE_DESC.CDELT', TYPE, DIM, CDELT, CDELT,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C
C                                       Set ANNABCOR keyword to T
      I = 1
      CALL PUTKEY (OUTOBJ, 'ANNABCOR', OOALOG, I, I, IERR)
      IF (IERR.NE.0) GO TO 999
C
C                                       History
      IF (NHIST.LT.NHMAX) THEN
         NHIST = NHIST+1
         WRITE(MYHIST(NHIST),1002)
     *      'Changed pixel scale by factor', SCALE
      ENDIF
C
      WRITE(MSGTXT,1002) 'Changed pixel scale by factor', SCALE
      CALL MSGWRT (1)
C                                       Clear file status
C      CALL IMCCLR (INOBJ, IERR)
C      IF (IERR.NE.0) GO TO 999
C                                       Close input image
      CALL OCLOSE (INOBJ, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Close output image
      CALL OCLOSE (OUTOBJ, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
1001  FORMAT (A)
1002  FORMAT (A,F10.7)
1003  FORMAT('Pixel size ',A,1P2E15.8)
1004  FORMAT (A,F10.3,A,F10.3)
      END

      REAL FUNCTION VLRNTZ (ALPHA, DELTA, JEPOCH)
C---------------------------------------------------------------------
C
C     This function determines the Lorentz Contraction caused by the
C  orbital motion of the earth.  The factor is used to correct the
C  scaling of VLA images.
C
C  ALPHA, DELTA are RA and Dec in degrees
C  JEPOCH is Julian epoch (e.g. 1990.23)
C
      DOUBLE PRECISION ALPHA, DELTA
      REAL JEPOCH
      REAL XV, YV, ZV, XS, YS, ZS, VMTION, PI, DEG2RD
      DATA PI/3.14159265358979323/
C
      DEG2RD = PI / 180.0
C
      CALL EVEL (JEPOCH, XV, YV, ZV, XS, YS, ZS)
C
C       Motion towards source
C
      VMTION = XV * COS(DEG2RD*ALPHA) * COS(DEG2RD*DELTA) + 
     *         YV * SIN(DEG2RD*ALPHA) * COS(DEG2RD*DELTA) +
     *         ZV * SIN(DEG2RD*DELTA)
C
C       Determine Lorentz factor = 1 + VMTION / c
C
      VLRNTZ = 1.0 + VMTION
C
      RETURN
      END

      SUBROUTINE EVEL (EPOCH, XV, YV, ZV, XS, YS, ZS)
C----------------------------------------------------------------------
C
C     Subroutine EVEL determines the earth orbital velocity and the
C  solar positions at any EPOCH.
C
C
C    INPUTS:
C        EPOCH    REAL   The epoch (egs. 1993.453)
C
C    OUTPUTS:
C        XV       REAL   Velocity towards (RA=0, DEC=0)
C        YV       REAL   Velocity towards (RA=90, DEC=0)
C        ZV       REAL   Velocity towards (DEC=90)
C        XS       REAL   Solar position towards (RA=0, DEC=0)
C        YS       REAL   Solar position towards (RA=90, DEC=0)
C        ZS       REAL   Solar position towards (DEC=90)
C
C
      REAL EPOCH, XV, YV, ZV, XS, YS, ZS
      REAL JDATE, L, G, LAMBDA, EPS, RAD, PI, DEG2RD
      DATA PI/3.14159265358979323/
C
      DEG2RD = PI / 180.0
C
C
C       Get Julian Day
C
      JDATE = (EPOCH - 2000.0) * 365.25
C
C       Get mean longitude of Sun, corrected for aberration
C
      L = DEG2RD * (280.460 + 0.9856474 * JDATE)
C
C       Get mean anomoly
C
      G = DEG2RD * (357.528 + 0.9856003 * JDATE)
C
C       Calculate ecliptic longitude
C
      LAMBDA = L + DEG2RD * (1.915 * SIN (G) + 0.020 * SIN (2.0*G))
      LAMBDA = AMOD (LAMBDA, 2.0*PI)
C
C       Obliquity of ecliptic
C
      EPS = DEG2RD * (23.439 - 0.0000004 * JDATE)
C
C       Sun-Earth distance
C
      RAD = 1.00014 - 0.01671 * COS (G) - 0.00014 * COS (2.0*G)
C
C       Solar coordinates
C
      XS = RAD * COS (LAMBDA)
      YS = RAD * COS (EPS) * SIN (LAMBDA)
      ZS = RAD * SIN (EPS) * SIN (LAMBDA)
C
C       Earth velocity
C
      XV =  0.0172 * SIN (LAMBDA) / 173.14
      YV = -0.0158 * COS (LAMBDA) / 173.14
      ZV = -0.0068 * COS (LAMBDA) / 173.14
C
      RETURN
      END
