LOCAL INCLUDE 'QCLEAN.INC'
C                                       Include for CLEAN class.
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
      INTEGER   SIZROW
C                                       SIZROW = SIZE of row buffers
      PARAMETER (SIZROW = 8192)
      INTEGER   MFIELD, NCLNG(MAXFLD), NSUBG(MAXFLD), CCDISK(MAXFLD),
     *   CCCNO(MAXFLD), CCVER(MAXFLD), IMSIZE(2,MAXFLD), ICNTRX(MAXFLD),
     *   ICNTRY(MAXFLD), NXBEM, NYBEM, NBMHIS, BMHIS(516),
     *   NBOXES(MAXFLD), WIN(4,10,MAXFLD), NRSBIN, MAXPCH, MINPCH,
     *   PATCH, NRESKP, APRESD, APCFLD(MAXFLD), APCLCN(MAXFLD),
     *   RESNUM, CLNLIM, CHANN, APBEAM, UVCHAN, NCHAV
      LOGICAL   ACTIVE, FINISH, FSTCLN, WFIRST, NOREST, USEFIT, NEWBEM
      REAL      CELLSG(2), XPOFF(MAXFLD), YPOFF(MAXFLD), MAPROT, BEMMAX,
     *   BMAJ, BMIN, BPA, GAUSAA, GAUSBB, GAUSCC, RESHIS(1024),
     *   RESMAX, MAPLIM, GAIN, PHAT, MINFLX, FACTOR, TFLUXG,
     *   FLUXG(MAXFLD),
     *   ROW1(SIZROW), ROW2(SIZROW), ROW3(SIZROW)
      CHARACTER DNAME(MAXFLD)*32, UVDATA*32, CNAME(MAXFLD)*32,
     *   DBNAME*32, GRID*32, TRANFN*32, WORK1*32, WORK2*32 
      COMMON /CLNPRI/ CELLSG, XPOFF, YPOFF, MAPROT, BEMMAX, BMAJ, BMIN,
     *   BPA, GAUSAA, GAUSBB, GAUSCC, RESHIS, RESMAX, MAPLIM,
     *   GAIN, PHAT, MINFLX, FACTOR, TFLUXG, FLUXG,
     *   ROW1, ROW2, ROW3,
     *   MFIELD, NCLNG, NSUBG, CCDISK, CCCNO, CCVER, IMSIZE, ICNTRX,
     *   ICNTRY, NXBEM, NYBEM, NBMHIS, BMHIS, NBOXES, WIN, NRSBIN,
     *   MAXPCH, MINPCH, PATCH, NRESKP, APRESD, APCFLD, APCLCN, RESNUM,
     *   CLNLIM, CHANN, APBEAM, UVCHAN, NCHAV,
     *   FINISH, ACTIVE, FSTCLN, WFIRST, NOREST, USEFIT, NEWBEM
      COMMON /CLNPRC/ DNAME, UVDATA, CNAME, DBNAME, GRID, TRANFN, WORK1,
     *   WORK2
C                                                         End QCLEAN.INC
LOCAL END
      SUBROUTINE CLREST (IRET)
C-----------------------------------------------------------------------
C  CLREST computes the CLEAN components convolved with the restoring
C  beam and adds it to each residual image.  Sums total clean flux.
C
C*** This version modified so that it does not add the residual image,
C*** but instead produces the clean component image only as output.
C*** This is a klugy way to get the clean-only image out.
C
C   Input from commons:
C      MFIELD     I         Number of fields present.
C      CNAME     C(*)*32   Names of associated clean (residual) images.
C      IMSIZE     I(2,*)    Image sizes 
C   Output to common:
C   Output: 
C      IRET       I    Return error code, 0=>OK, otherwise failed.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INTEGER   IFIELD, BLC(7), TRC(7), DIM(7), TYPE
      CHARACTER TGRID*32
      INCLUDE 'QCLEAN.INC'
C-----------------------------------------------------------------------
      MSGTXT = 'Restoring CLEAN components'
      CALL MSGWRT (3)
C                                       Loop over fields.
      DO 100 IFIELD = 1,MFIELD
C                                       Make sure that there are
C                                       components.
         IF (NCLNG(IFIELD).GT.0) THEN
C                                       Grid transform of restoring
C                                       beam.
            CALL CLRGRD (IFIELD, TGRID, IRET)
C                                       Check if CC found.
            IF (IRET.EQ.10) GO TO 100
            IF (IRET.NE.0) GO TO 995
C                                       FFT
            CALL ARRFFT (-1, TGRID, WORK1, WORK2, IRET)
            IF (IRET.NE.0) GO TO 995
C                                       Set window for residual/restored
            CALL ARDGET (CNAME(IFIELD), 'BLC', TYPE, DIM, BLC, BLC,
     *         IRET) 
            IF (IRET.NE.0) GO TO 995
            CALL ARDGET (CNAME(IFIELD), 'TRC', TYPE, DIM, TRC, TRC,
     *         IRET) 
            IF (IRET.NE.0) GO TO 995
            BLC(1) = 1
            BLC(2) = 1
            BLC(3) = CHANN
            TRC(1) = IMSIZE(1,IFIELD)
            TRC(2) = IMSIZE(2,IFIELD)
            TRC(3) = CHANN
            CALL ARDPUT (CNAME(IFIELD), 'BLC', TYPE, DIM, BLC, BLC,
     *         IRET) 
            IF (IRET.NE.0) GO TO 995
            CALL ARDPUT (CNAME(IFIELD), 'TRC', TYPE, DIM, TRC, TRC,
     *         IRET)
            IF (IRET.NE.0) GO TO 995
C***                                    COPY to residual
            CALL ARRCOP (WORK2, CNAME(IFIELD), IRET)
            IF (IRET.NE.0) GO TO 995
            END IF
 100     CONTINUE
      IRET = 0
      GO TO 999
C
 990  CALL MSGWRT (8)
 995  MSGTXT = 'CLREST: ERROR RESTORING ' // CNAME(IFIELD)
      CALL MSGWRT (8)
C
 999  RETURN
      END
