LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER NPARMS
C                                       NPARMS=no. adverbs passed.
C USERID     User number.
C INNAME     Main input file (name).
C INCLASS    Main input file (class).
C INSEQ      Main input file (seq. #).
C INDISK     Disk unit #.       0 => any
C INVERS     Input  file version no.
C STFACTOR   Fractional change in scale for map.
C ROTATE     Rotation in degrees.
C
      PARAMETER (NPARMS=8)
      INTEGER AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END

LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
C                                       Adverb names
C                      1          2         3          4        5
      DATA AVNAME /'USERID',   'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
C           6          7          8
     *   'INVER',  'STFACTOR', 'ROTATE' /
C                                       Adverb data types (PAOOF.INC)
C                      1        2         3          4        5
      DATA AVTYPE /  OOAINT,  OOACAR,   OOACAR,    OOAINT,  OOAINT,
C           6          7        8
     *    OOAINT,    OOARE,   OOARE /
C                                       Adverb dimensions (as 2D)
C                      1        2         3          4        5
      DATA AVDIM /   1,1,    12,1,      6,1,       1,1,     1,1,
C           6          7        8
     *    1,1,       1,1,     1,1 /
LOCAL END

      PROGRAM FIXMP
C-----------------------------------------------------------------------
C! Change map scale and rotation by setting keywords
C# Utility OOP
C   This software is the subject of a User agreement and is confidential
C   in nature. It shall not be sold or otherwise made available or
C   disclosed to third parties.
C-----------------------------------------------------------------------
      INTEGER  IERR, BUFF1(256)
      INTEGER NHIST, NHMAX
      PARAMETER (NHMAX = 20)
      CHARACTER PRGM*6, INOBJ*32, OUTOBJ*32, MYHIST(NHMAX)*72
      DATA PRGM /'FIXMP '/, NHIST /0/
C-----------------------------------------------------------------------
C                                       Startup
      CALL FXMPIN (PRGM, INOBJ, OUTOBJ, IERR)
C                                       Do action
      IF (IERR.EQ.0) CALL FXMPAB (INOBJ, OUTOBJ, MYHIST, NHMAX,
     *   NHIST, IERR)
C                                       History
      IF (IERR.EQ.0) CALL FXMPHI (OUTOBJ, MYHIST, NHIST)
C                                       Close down files, etc.
 990  CALL DIE (IERR, BUFF1)
C
 999  STOP
      END

      SUBROUTINE FXMPIN (PRGN, INOBJ, OUTOBJ, IERR)
C-----------------------------------------------------------------------
C   FXMPIN gets input parameters for FIXMP and creates the input and
C   output object.
C
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      INOBJ   C*32 Input object name
C      OUTOBJ  C*32 Output object name
C      IERR    I    Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER PRGN*6, INOBJ*32, OUTOBJ*32
C
      INTEGER   NKEY1
C                                       NKEY1=no. adverbs to copy to INOBJ
      PARAMETER (NKEY1=8)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs to copy to INOBJ
C                      1         2         3          4        5
      DATA INK1   /'USERID',  'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
C           6          7         8
     *   'INVER',  'STFACTOR','ROTATE' /
C                                       May rename adverbs to INOBJ
C                      1        2         3          4        5
      DATA OUTK1  /'USERID', 'NAME',   'CLASS',   'IMSEQ',   'DISK',
C           6          7         8
     *   'VER',    'STFACTOR','ROTATE' /
C
C-----------------------------------------------------------------------
C                                       Startup,  returns "Input" object
C                                       containing POPS adverbs
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Create input object
      INOBJ = 'Input object'
      CALL CREATE (INOBJ, 'IMAGE', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, INOBJ, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Shallow copy image for write
      OUTOBJ = 'Shallow copy'
      CALL OCOPY (INOBJ, OUTOBJ, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END

      SUBROUTINE FXMPHI (OUTOBJ, MYHIST, NHIST)
C-----------------------------------------------------------------------
C   Routine to write history file to output object.  This assumes
C   that a previous history exists and merely adds the information from
C   the current task.
C
C   If NHIST=0 then no history records are written.
C
C   Inputs:
C      OUTOBJ  C*?  Output object
C      MYHIST  C*72 Array (NHIST) of extra history lines
C-----------------------------------------------------------------------
      INTEGER NHIST
      CHARACTER OUTOBJ*(*), MYHIST(NHIST)*72
C
      INTEGER   NADV, I
      PARAMETER (NADV=6)
      CHARACTER LIST(NADV)*8
      INTEGER   IERR
      INCLUDE 'INCS:DMSG.INC'
C                                       Adverbs to copy to history
      DATA LIST /'INNAME', 'INCLASS', 'INSEQ', 'INVER',
     *   'STFACTOR', 'ROTATE' /
C-----------------------------------------------------------------------
C
      IF (NHIST.EQ.0) RETURN
C                                       Add task label to history
      CALL OHTIME (OUTOBJ, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Copy adverb values.
      CALL OHLIST ('Input', LIST, NADV, OUTOBJ, IERR)
      IF (IERR.NE.0) GO TO 990
C
C                                       Add info on results.
      DO 10 I=1,NHIST
         CALL OHWRIT(MYHIST(I), OUTOBJ, IERR)
         IF (IERR.NE.0) GO TO 990
  10  CONTINUE
C
      CALL OCLOSE (OUTOBJ, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // OUTOBJ
      CALL MSGWRT (4)
 999  RETURN
      END

      SUBROUTINE FXMPAB (INOBJ, OUTOBJ, MYHIST, NHMAX, NHIST, IERR)
C-----------------------------------------------------------------------
C   Apply scale change and rotation by changing pixel sizes and
C   rotation angle in header.
C   Inputs:
C      INOBJ   C*   Name of input object.
C      NHMAX   I    Maximum number of history lines to write.
C   Output:
C      MYHIST  C*72 History lines.
C      NHIST   I    Number of history lines written.
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   NHMAX, NHIST, IERR
      CHARACTER INOBJ*(*), OUTOBJ*(*), MYHIST(NHMAX)*72
C
C
      INTEGER   TYPE, DIM(7), DIM2(7), ICORR, MSGSAV, KILSAV
      REAL STFACT, ROTATE, CDELT(7), CROTA(7)
      CHARACTER CDUMMY*1
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Open input & output objects
      CALL OOPEN (INOBJ, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OOPEN (OUTOBJ, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Make new header keywords
      CALL OBVHKW ('IMAGE   ', 'FIXMPCOR', OOALOG, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBVHKW ('IMAGE   ', 'FIXMPCD1', OOARE, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBVHKW ('IMAGE   ', 'FIXMPCD2', OOARE, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBVHKW ('IMAGE   ', 'FIXMPROT', OOARE, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Check whether correction already done
C                                       Suppress warning messages.
      MSGSAV = MSGSUP
      KILSAV = MSGKIL
      MSGSUP = 32000
      MSGKIL = 32007
      CALL OGET (INOBJ, 'FIXMPCOR', TYPE, DIM, ICORR, CDUMMY, IERR)
      MSGSUP = MSGSAV
      MSGKIL = KILSAV
      IF (IERR.NE.0) THEN
C                                       Assume that correction has not been done
         IERR = 0
      ELSE IF (TYPE .NE. OOALOG) THEN
C                                       Keyword is present but is not logical!
         WRITE (MSGTXT, 1001)
     *      'Keyword FIXMPCOR is not of type logical!'
         CALL MSGWRT (4)
         IERR = 1
         GO TO 999
      ENDIF
C
C                                       Get old pixel sizes, rotation
      CALL OGET (INOBJ, 'IMAGE_DESC.CDELT', TYPE, DIM, CDELT, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INOBJ, 'IMAGE_DESC.CROTA', TYPE, DIM, CROTA, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C
      IF (ICORR .NE. 0) THEN
C
C                                       Correction was already done
         WRITE (MSGTXT, 1001) 'Warning: FIXMPCOR=T, correction ' //
     *      'will be applied to original values'
         CALL MSGWRT (1)
C                                       Restore old pixel sizes & rotation
         CALL OGET (INOBJ, 'FIXMPCD1', TYPE, DIM2, CDELT(1), CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OGET (INOBJ, 'FIXMPCD2', TYPE, DIM2, CDELT(2), CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OGET (INOBJ, 'FIXMPROT', TYPE, DIM2, CROTA(2), CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
C
      ELSE
C
C                                       Save old pixel sizes and rotation
         DIM2(1) = 1
         DIM2(2) = 0
         CALL OPUT (OUTOBJ, 'FIXMPCD1', OOARE, DIM2, CDELT(1), CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OPUT (OUTOBJ, 'FIXMPCD2', OOARE, DIM2, CDELT(2), CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OPUT (OUTOBJ, 'FIXMPROT', OOARE, DIM2, CROTA(2), CDUMMY,
     *      IERR)
         IF (IERR.NE.0) GO TO 999
      ENDIF
C
C                                       Get new scale, rotation
      CALL OGET (OUTOBJ, 'STFACTOR', TYPE, DIM2, STFACT, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (OUTOBJ, 'ROTATE',   TYPE, DIM2, ROTATE,   CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C
C                                       Change pixel sizes & rotation
      CDELT(1) = CDELT(1)*(1+STFACT)
      CDELT(2) = CDELT(2)*(1+STFACT)
      CALL OPUT (OUTOBJ, 'IMAGE_DESC.CDELT', TYPE, DIM, CDELT, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
      CROTA(2) = CROTA(2) + ROTATE
      CALL OPUT (OUTOBJ, 'IMAGE_DESC.CROTA', TYPE, DIM, CROTA, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C
C                                       Set FIXMPCOR keyword to T
      ICORR = 1
      CALL PUTKEY (OUTOBJ, 'FIXMPCOR', OOALOG, ICORR, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C
C                                       History
      IF (NHIST.LT.NHMAX) THEN
         NHIST = NHIST+1
         WRITE(MYHIST(NHIST),1002)
     *      'Changed pixel scale by fraction', STFACT,
     *      ' rotated by', ROTATE
      ENDIF
C
      WRITE(MSGTXT,1002) 'Changed pixel scale by fraction', STFACT,
     *      ' rotated by', ROTATE
      CALL MSGWRT (1)
C                                       Clear file status
C      CALL IMCCLR (INOBJ, IERR)
C      IF (IERR.NE.0) GO TO 999
C                                       Close input image
      CALL OCLOSE (INOBJ, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Close output image
      CALL OCLOSE (OUTOBJ, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
1001  FORMAT (A)
1002  FORMAT (A,F10.7,A,F10.7)
1003  FORMAT('Pixel size ',A,1P2E15.8)
1004  FORMAT (A,F10.3,A,F10.3)
      END
