LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER NPARMS
      PARAMETER (NPARMS=8)
      INTEGER AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
      INCLUDE 'INCS:PAOOF.INC'
      DATA AVNAME / 'INNAME',   'INCLASS', 'INSEQ', 'INDISK',
     *   'IN2NAME', 'IN2CLASS', 'IN2SEQ',  'IN2DISK'/
      DATA AVTYPE /  OOACAR,     OOACAR,    OOAINT,  OOAINT,
     *    OOACAR,    OOACAR,     OOAINT,    OOAINT/
      DATA AVDIM /     12,1,        6,1,       1,1,     1,1,
     *      12,1,       6,1,        1,1,       1,1/
LOCAL END
      PROGRAM GETSB
C-----------------------------------------------------------------------
C! Computes part of image 1 that overlaps with image 2
C# Task MAP-UTIL AP OOP
C   This software is the subject of a User agreement and is confidential
C   in nature. It shall not be sold or otherwise made available or
C   disclosed to third parties.
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, IN*32, IN2*32
      INTEGER  IERR, BUFF1(256)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'GETSB '/
C-----------------------------------------------------------------------
C                                       Startup
      CALL GTSBIN (PRGM, IN, IN2, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Do the action
      CALL GTSBAB (IN, IN2, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       History
      CALL GTSBHI (IN)
C                                       Close down files, etc.
 990  CALL DIE (IERR, BUFF1)
C
 999  STOP
      END

      SUBROUTINE GTSBIN (PRGN, IN, IN2, IERR)
C-----------------------------------------------------------------------
C   GTSBIN gets input parameters for GETSB and creates the objects.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IN      C*?  Input image object
C      IN2     C*?  Input object 2 (reference image)
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER PRGN*6, IN*(*), IN2*(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NKEY1, NKEY2
C                                       NKEY1=no. adverbs for IN
      PARAMETER (NKEY1=4)
C                                       NKEY2=no. adverbs for IN2
      PARAMETER (NKEY2=4)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, INK2(NKEY2)*8,
     *   OUTK2(NKEY2)*32
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs for IN
C                    1          2        3        4
      DATA INK1 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK'/
C                                       Rename
C                    1       2       3        4
      DATA OUTK1 /'NAME', 'CLASS', 'IMSEQ', 'DISK'/
C                                       Adverbs for IN2
C                    1          2        3        4
      DATA INK2 /'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK'/
C                                       Rename
C                    1       2       3        4
      DATA OUTK2 /'NAME', 'CLASS', 'IMSEQ', 'DISK'/
C-----------------------------------------------------------------------
C                                       Startup
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Create IN
      IN = 'Input image object'
      CALL CREATE (IN, 'IMAGE', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, IN, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open and close to check that
C                                       it's OK
      CALL OOPEN (IN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OCLOSE (IN, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Create IN2
      IN2 = 'Input reference image object'
      CALL CREATE (IN2, 'IMAGE', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY2, INK2, OUTK2, IN2, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open and close to check that
C                                       it's OK
      CALL OOPEN (IN2, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OCLOSE (IN2, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END

      SUBROUTINE GTSBHI (IN)
C-----------------------------------------------------------------------
C   Routine to write history file to output.
C   Inputs:
C      IN      C*?  Input object
C-----------------------------------------------------------------------
      CHARACTER IN*(*)
C
      INTEGER   IERR
      INTEGER   NADV
      PARAMETER (NADV=8)
      CHARACTER LIST(NADV)*8
      INCLUDE 'INCS:DMSG.INC'
C                                       Adverbs to copy to history
      DATA LIST /'INNAME',  'INCLASS',  'INSEQ',  'INDISK',
     *           'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK'/
C-----------------------------------------------------------------------
C                                        Set time of task
      CALL OHTIME (IN, IERR)
      IF (IERR.NE.0) GO TO 990
C                                        New additions - copy adverb
C                                        values.
      CALL OHLIST ('Input', LIST, NADV, IN, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // IN
      CALL MSGWRT (6)
 999  RETURN
      END

      SUBROUTINE GTSBAB (IN, REFOBJ, IERR)
C-----------------------------------------------------------------------
C   Compute subimage of IN that overlaps with REFOBJ and write keywords
C   Inputs:
C      IN      C*   Name of input image object.
C      REFOBJ  C*   Name of input reference image object.
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER IN*(*), REFOBJ*(*)
C
      INTEGER   J, TYPE, DIM(7), NAXIS(7), NAXREF(7), NX, NY
      REAL    XYZI(7), XYZO(7), X1, X2, Y1, Y2
      INTEGER BLC(2), TRC(2), IROUND
      CHARACTER CDUMMY*1
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA XYZI/7*1.0/
C-----------------------------------------------------------------------
C                                       Open input objects
      CALL OOPEN (IN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OOPEN (REFOBJ, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get input image dimensions
      CALL OGET (IN, 'ARRAY.ARRAY_DESC.NAXIS', TYPE, DIM,
     *   NAXIS, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (REFOBJ, 'ARRAY.ARRAY_DESC.NAXIS', TYPE, DIM,
     *   NAXREF, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Go around edge of reference image
C                                       checking how pixel positions map
C                                       into input image.  Save extremes.
      NX = NAXREF(1)
      NY = NAXREF(2)
      X1 = NAXIS(1)
      X2 = 1.0
      Y1 = NAXIS(2)
      Y2 = 1.0
      DO 10 J=1,10
         XYZI(1) = 1.0 + NX*(J-1)/10
         XYZI(2) = 1.0
         CALL PSNCVT(REFOBJ, XYZI, IN, XYZO, IERR)
         IF (IERR.NE.0) GO TO 999
         X1 = MIN(X1, XYZO(1))
         X2 = MAX(X2, XYZO(1))
         Y1 = MIN(Y1, XYZO(2))
         Y2 = MAX(Y2, XYZO(2))
         XYZI(1) = NX*J/10
         XYZI(2) = NY
         CALL PSNCVT(REFOBJ, XYZI, IN, XYZO, IERR)
         IF (IERR.NE.0) GO TO 999
         X1 = MIN(X1, XYZO(1))
         X2 = MAX(X2, XYZO(1))
         Y1 = MIN(Y1, XYZO(2))
         Y2 = MAX(Y2, XYZO(2))
         XYZI(1) = 1.0
         XYZI(2) = NY*J/10
         CALL PSNCVT(REFOBJ, XYZI, IN, XYZO, IERR)
         IF (IERR.NE.0) GO TO 999
         X1 = MIN(X1, XYZO(1))
         X2 = MAX(X2, XYZO(1))
         Y1 = MIN(Y1, XYZO(2))
         Y2 = MAX(Y2, XYZO(2))
         XYZI(1) = NX
         XYZI(2) = 1.0 + NY*(J-1)/10
         CALL PSNCVT(REFOBJ, XYZI, IN, XYZO, IERR)
         IF (IERR.NE.0) GO TO 999
         X1 = MIN(X1, XYZO(1))
         X2 = MAX(X2, XYZO(1))
         Y1 = MIN(Y1, XYZO(2))
         Y2 = MAX(Y2, XYZO(2))
  10  CONTINUE
C                                       Add 10 pixels on all sides
C                                       and trim to fit in input image
      X1 = MIN( MAX(X1-10,1.0), FLOAT(NAXIS(1)) )
      X2 = MIN( MAX(X2+10,1.0), FLOAT(NAXIS(1)) )
      Y1 = MIN( MAX(Y1-10,1.0), FLOAT(NAXIS(2)) )
      Y2 = MIN( MAX(Y2+10,1.0), FLOAT(NAXIS(2)) )
C                                       Convert pixel values to integers
      BLC(1) = IROUND(X1)
      BLC(2) = IROUND(Y1)
      TRC(1) = IROUND(X2)
      TRC(2) = IROUND(Y2)
      WRITE (MSGTXT, 1001) BLC(1),BLC(2),TRC(1),TRC(2)
      CALL MSGWRT (1)
C                                       Write header keywords
      CALL PUTKEY (IN, 'SUBBLC1', OOAINT, BLC(1), CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL PUTKEY (IN, 'SUBBLC2', OOAINT, BLC(2), CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL PUTKEY (IN, 'SUBTRC1', OOAINT, TRC(1), CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL PUTKEY (IN, 'SUBTRC2', OOAINT, TRC(2), CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Close input objects
      CALL OCLOSE (IN, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OCLOSE (REFOBJ, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
1001  FORMAT ('Overlapping subimage has BLC=',I5,I5,' TRC=',I5,I5)
      END
