LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER NPARMS
C                                       NPARMS=no. adverbs passed.
      PARAMETER (NPARMS=7)
      INTEGER AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
C                                       NOTE: Uses values in PAOOF.INC
C                                       Adverb names
C                      1        2         3           4        5
      DATA AVNAME /'USERID', 'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
C           6         7
     *   'INEXT', 'OUTVERS'/
C                                       Adverb data types (PAOOF.INC)
C                     1         2         3           4        5
      DATA AVTYPE /OOAINT,   OOACAR,   OOACAR,    OOAINT,  OOAINT,
C          6          7
     *   OOACAR,   OOAINT/
C                                       Adverb dimensions (as 2D)
C                     1         2         3           4        5
      DATA AVDIM /  1,1,     12,1,      6,1,        1,1,     1,1,
C          6          7
     *   2,1,       1,1/
LOCAL END
      PROGRAM NEWTB
C-----------------------------------------------------------------------
C! Test OOP task for tables: create a table of specified type
C# Calibration VLBI
C   This software is the subject of a User agreement and is confidential
C   in nature. It shall not be sold or otherwise made available or
C   disclosed to third parties.
C-----------------------------------------------------------------------
C   Test OOP task for tables: create a table of specified type
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, OUTOBJ*36
      INTEGER  IRET, BUFF1(256)
      DATA PRGM /'NEWTB '/
C-----------------------------------------------------------------------
C                                       Startup
      CALL NWTBIN (PRGM, OUTOBJ, IRET)
C                                       Process table
      IF (IRET.EQ.0) CALL NWTBAB (OUTOBJ, IRET)
C                                       History
      IF (IRET.EQ.0) CALL NWTBHI (OUTOBJ)
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END
      SUBROUTINE NWTBIN (PRGN, OUTOBJ, IRET)
C-----------------------------------------------------------------------
C   NWTBIN gets input parameters for NEWTB and creates the output object
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6, OUTOBJ*36
C
C                                       NKEY1=no. adverbs to copy to
C                                       OUTOBJ
      INTEGER   NKEY1
      PARAMETER (NKEY1=7)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs to copy to OUTOBJ
C                    1         2          3        4         5
      DATA INK1 /'USERID', 'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
C           6        7
     *   'OUTVERS', 'INEXT'/
C                                       May rename adverbs to OUTOBJ
C                    1         2          3        4         5
      DATA OUTK1 /'USERID', 'NAME', 'CLASS', 'IMSEQ', 'DISK',
C           6        7
     *    'VER',   'TBLTYPE'/
C-----------------------------------------------------------------------
C                                       Startup,  returns "Input" object
C                                       containing POPS adverbs
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create output object
      OUTOBJ = 'Output object'
      CALL CREATE (OUTOBJ, 'TABLE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, OUTOBJ, IRET)
      IF (IRET.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE NWTBAB (OUTOBJ, IERR)
C-----------------------------------------------------------------------
C   Create table.
C   This example creates a simple table.
C   Inputs:
C      OUTOBJ   C*   Name of output table object.
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER OUTOBJ*(*)
      INTEGER   IERR
C                                       TLABEL = table label
      CHARACTER*56 TLABEL
      PARAMETER (TLABEL = 'This is a simple test table.')
C                                       NCOL = number of columns
      INTEGER NCOL
      PARAMETER (NCOL = 2)
C                                       CLABEL = column labels
      CHARACTER CLABEL*(24*NCOL)
C                                       CUNIT = column units
      CHARACTER CUNIT*(8*NCOL)
C                                       CTYPE = column types
      INTEGER CTYPE(NCOL)
C                                       CDIM = column dimensions
      INTEGER CDIM(NCOL)
C
      CHARACTER*12 TNAME
      INTEGER   IROW, TYPE, DIM(7), IVER
      REAL      DUMMY
      CHARACTER CDUMMY
C
      INCLUDE 'INCS:PAOOF.INC'
C-----------------------------------------------------------------------
C                                       Table label
      DIM(1) = LEN(TLABEL)
      DIM(2) = 1
      DIM(3) = 0
      CALL OPUT (OUTOBJ, 'LABEL', OOACAR, DIM, DUMMY, TLABEL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Number of columns
      DIM(1) = 1
      DIM(2) = 1
      DIM(3) = 0
      CALL OPUT (OUTOBJ, 'NCOL', OOAINT, DIM, NCOL, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Column labels
      CLABEL( 1:24) = 'FLDNAME'
      CLABEL(25:48) = 'STATUS'
      DIM(1) = 24
      DIM(2) = NCOL
      DIM(3) = 0
      CALL OPUT (OUTOBJ, 'COLABEL', OOACAR, DIM, DUMMY, CLABEL, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Column units
      CUNIT(1:8) = ' '
      CUNIT(9:16) = ' '
      DIM(1) = 8
      DIM(2) = NCOL
      DIM(3) = 0
      CALL OPUT (OUTOBJ, 'COLUNIT', OOACAR, DIM, DUMMY, CUNIT, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Column types
      CTYPE(1) = OOACAR
      CTYPE(2) = OOACAR
      DIM(1) = NCOL
      DIM(2) = 1
      DIM(3) = 0
      CALL OPUT (OUTOBJ, 'COLTYPE', OOAINT, DIM, CTYPE, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Column dimensions
      CDIM(1) = 12
      CDIM(2) = 1
      DIM(1) = NCOL
      DIM(2) = 1
      DIM(3) = 0
      CALL OPUT (OUTOBJ, 'COLDIM', OOAINT, DIM, CDIM, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Set version number to 1 if 0
      CALL OGET (OUTOBJ, 'VER', TYPE, DIM, IVER, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      IF (IVER.LE.0) THEN
C         IVER = 1
C         CALL OPUT (OUTOBJ, 'VER', TYPE, DIM, IVER, CDUMMY, IERR)
C         IF (IERR.NE.0) GO TO 999
      ENDIF
C                                       Create output table
      CALL TABOPN (OUTOBJ, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 999
C
C                                       Now write entries for 3 rows
      DO 100 IROW = 1,3
         WRITE(TNAME,1001) IROW
 1001    FORMAT('Test Name',I3)
         DIM(1) = CDIM(1)
         DIM(2) = 1
         DIM(3) = 0
         CALL TABDPT (OUTOBJ, IROW, 1, OOACAR, DIM, DUMMY,
     *      TNAME, IERR) 
         IF (IERR.NE.0) GO TO 999
         DIM(1) = CDIM(2)
         DIM(2) = 1
         DIM(3) = 0
         CALL TABDPT (OUTOBJ, IROW, 2, OOACAR, DIM, DUMMY,
     *      'Y', IERR) 
         IF (IERR.NE.0) GO TO 999
 100  CONTINUE
C                                       Close table
      CALL OCLOSE (OUTOBJ, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END
      SUBROUTINE NWTBHI (OUTOBJ)
C-----------------------------------------------------------------------
C   Routine to write history file to output table object.  This assumes
C   that a previous history exists and merely adds the information from
C   the current task.
C   Inputs:
C      OUTOBJ  C*?  Output table object
C-----------------------------------------------------------------------
      CHARACTER OUTOBJ*(*)
C
      INTEGER   NADV
      PARAMETER (NADV=5)
      CHARACTER LIST(NADV)*8
      INTEGER   IERR
      INCLUDE 'INCS:DMSG.INC'
C                                       Adverbs to copy to history
      DATA LIST /'INNAME', 'INCLASS', 'INSEQ', 'OUTVERS', 'INEXT'/
C-----------------------------------------------------------------------
C                                       Add task label to history
      CALL OHTIME (OUTOBJ, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Copy adverb values.
      CALL OHLIST ('Input', LIST, NADV, OUTOBJ, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // OUTOBJ
      CALL MSGWRT (4)
 999  RETURN
      END
