LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER NPARMS
      PARAMETER (NPARMS=8)
      INTEGER AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
      INCLUDE 'INCS:PAOOF.INC'
      DATA AVNAME /'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
     *   'KEYWORD', 'KEYVALUE', 'KEYSTRNG', 'KEYTYPE'/
      DATA AVTYPE /OOACAR, OOACAR, OOAINT, OOAINT, 
     *   OOACAR, OOARE, OOACAR, OOACAR/ 
      DATA AVDIM /12,1, 6,1, 1,1, 1,1, 
     *   8,1, 2,1, 16,1, 4,1/
LOCAL END
      PROGRAM PUTKY
C-----------------------------------------------------------------------
C! Write keyword to header (task equivalent of verb PUTHEAD)
C# Task CATALOG OOP
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      INTEGER NHIST, NHMAX, IRET, BUFF1(256)
      PARAMETER (NHMAX = 20)
      CHARACTER PRGM*6, IN*32, MYHIST(NHMAX)*72
      DATA PRGM /'PUTKY '/, NHIST /0/
C-----------------------------------------------------------------------
C                                       Startup
      CALL PTKYIN (PRGM, IN, IRET)
C                                       Do action
      IF (IRET.EQ.0) CALL PTKYAB (IN, MYHIST, NHMAX,
     *   NHIST, IRET)
C                                       History
      IF (IRET.EQ.0) CALL PTKYHI (IN, MYHIST, NHIST)
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFF1)
C
 999  STOP
      END

      SUBROUTINE PTKYIN (PRGN, IN, IRET)
C-----------------------------------------------------------------------
C   PTKYIN gets input parameters for PUTKY.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IN      C*?  Input object
C      IRET    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   IRET
      CHARACTER PRGN*6, IN*(*)
C                                       NKEY1=no. adverbs for inname
      INTEGER   NKEY1
      PARAMETER (NKEY1=8)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs for IN
C                    1          2        3        4
      DATA INK1 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
C          5           6           7           8
     *   'KEYWORD', 'KEYVALUE', 'KEYSTRNG', 'KEYTYPE'/
C                                       Rename
C                    1       2       3        4
      DATA OUTK1 /'NAME', 'CLASS', 'IMSEQ', 'DISK',
C          5           6           7           8
     *   'KEYWORD', 'KEYVALUE', 'KEYSTRNG', 'KEYTYPE'/
C-----------------------------------------------------------------------
C                                       Startup
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create IN
      IN = 'Input image object'
      CALL CREATE (IN, 'IMAGE', IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, IN, IRET)
      IF (IRET.NE.0) GO TO 999
C
 999  RETURN
      END

      SUBROUTINE PTKYAB (IN, MYHIST, NHMAX, NHIST, IRET)
C-----------------------------------------------------------------------
C   PTKYAB sets the keyword value.
C   Inputs:
C      IN      C*?  Input object
C      NHMAX   I    Maximum number of history lines to write.
C   Output:
C      MYHIST  C*72 History lines.
C      NHIST   I    Number of history lines written.
C      IRET    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   NHMAX, NHIST, IRET
      CHARACTER IN*(*), MYHIST(NHMAX)*72
C
      INTEGER   DIM(7), TYPE
      REAL      KEYVAL(2)
      CHARACTER KEYWRD*8, KEYSTR*16, KEYTYP*4, CNAME*8
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPUTDATA.INC'
C-----------------------------------------------------------------------
C                                       Get keyword info
      CALL OGET ('Input', 'KEYWORD', TYPE, DIM, KEYWRD, KEYWRD, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'KEYVALUE', TYPE, DIM, KEYVAL, KEYVAL, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'KEYSTRNG', TYPE, DIM, KEYSTR, KEYSTR, IRET)
      IF (IRET.NE.0) GO TO 999
      CALL OGET ('Input', 'KEYTYPE', TYPE, DIM, KEYTYP, KEYTYP, IRET)
      IF (IRET.NE.0) GO TO 999
C
C                                       Open object
      CALL OOPEN (IN, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Declare KEYWORD a header
C                                       keyword for the image class,
C                                       put the value, and write
C                                       history lines.
      CNAME = 'IMAGE'
C
      NHIST = NHIST+1
      WRITE(MYHIST(NHIST),1001) KEYWRD, KEYTYP
 1001 FORMAT('KEYWORD = ''', A8,''', KEYTYPE = ''', A4,
     *   ''' / new catalog keyword')
      IF (KEYTYP.EQ.'C') THEN
C
         CALL OBVHKW (CNAME, KEYWRD, OOACAR, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OPUT (IN, KEYWRD, OOACAR, DIM, KEYSTR, KEYSTR, IRET)
         IF (IRET.NE.0) GO TO 999
         NHIST = NHIST+1
         WRITE(MYHIST(NHIST),1002) KEYSTR
 1002    FORMAT('KEYVALUE = ''', A,''' / Keyword value')
C
      ELSE IF (KEYTYP.EQ.'D') THEN
C
         CALL OBVHKW (CNAME, KEYWRD, OOADP, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OPUT (IN, KEYWRD, OOADP, DIM, KEYVAL, KEYVAL, IRET)
         IF (IRET.NE.0) GO TO 999
         NHIST = NHIST+1
         WRITE(MYHIST(NHIST),1003) DBLE(KEYVAL(1))+DBLE(KEYVAL(2))
 1003    FORMAT('KEYVALUE = ''',D20.13,' / Keyword value')
C
      ELSE IF (KEYTYP.EQ.'R') THEN
C
         CALL OBVHKW (CNAME, KEYWRD, OOARE, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OPUT (IN, KEYWRD, OOARE, DIM, KEYVAL, KEYVAL, IRET)
         IF (IRET.NE.0) GO TO 999
         NHIST = NHIST+1
         WRITE(MYHIST(NHIST),1004) KEYVAL(1)
 1004    FORMAT('KEYVALUE = ''',E14.7,' / Keyword value')
C
      ELSE IF (KEYTYP.EQ.'I') THEN
C
         CALL OBVHKW (CNAME, KEYWRD, OOAINT, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OPUT (IN, KEYWRD, OOAINT, DIM, KEYVAL, KEYVAL, IRET)
         IF (IRET.NE.0) GO TO 999
         NHIST = NHIST+1
         WRITE(MYHIST(NHIST),1005) INT(KEYVAL(1))
 1005    FORMAT('KEYVALUE = ''',I9,' / Keyword value')
C
      ELSE IF (KEYTYP.EQ.'L') THEN
C
         CALL OBVHKW (CNAME, KEYWRD, OOALOG, IRET)
         IF (IRET.NE.0) GO TO 999
         CALL OPUT (IN, KEYWRD, OOALOG, DIM, KEYVAL, KEYVAL, IRET)
         IF (IRET.NE.0) GO TO 999
         NHIST = NHIST+1
         WRITE(MYHIST(NHIST),1006) KEYVAL(1)
 1006    FORMAT('KEYVALUE = ''',E14.7,' / Keyword value')
C
      ELSE
C
         MSGTXT = 'Unknown KEYTYPE=' // KEYTYP
         CALL MSGWRT (8)
         IRET = 999
      ENDIF
C
 999  RETURN
      END

      SUBROUTINE PTKYHI (IN, MYHIST, NHIST)
C-----------------------------------------------------------------------
C   Routine to write history file to output object.  This assumes
C   that a previous history exists and merely adds the information from
C   the current task.
C   Inputs:
C      IN      C*?  Output object
C      MYHIST  C*72 Array (NHIST) of extra history lines
C      NHIST   I    Number of extra history lines
C-----------------------------------------------------------------------
      INTEGER NHIST
      CHARACTER IN*(*), MYHIST(NHIST)*72
C
      INTEGER   I
      INTEGER   IERR
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Add task label to history
      CALL OHTIME (IN, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       No adverbs listed for this task.
C                                       Add info on results.
      DO 10 I=1,NHIST
         CALL OHWRIT(MYHIST(I), IN, IERR)
         IF (IERR.NE.0) GO TO 990
  10  CONTINUE
C
      CALL OCLOSE (IN, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'Error writing history for ' // IN
      CALL MSGWRT (4)
 999  RETURN
      END
