LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER NPARMS
      PARAMETER (NPARMS=12)
      INTEGER AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END
LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
      INCLUDE 'INCS:PAOOF.INC'
      DATA AVNAME / 'INNAME',   'INCLASS', 'INSEQ', 'INDISK',
     *   'IN2NAME', 'IN2CLASS', 'IN2SEQ',  'IN2DISK',
     *   'OUTNAME', 'OUTCLASS', 'OUTSEQ',  'OUTDISK'/
      DATA AVTYPE /  OOACAR,     OOACAR,    OOAINT,  OOAINT,
     *    OOACAR,    OOACAR,     OOAINT,    OOAINT,
     *    OOACAR,    OOACAR,     OOAINT,    OOAINT/
      DATA AVDIM /     12,1,        6,1,       1,1,     1,1,
     *      12,1,       6,1,        1,1,       1,1,
     *      12,1,       6,1,        1,1,       1,1/
LOCAL END
      PROGRAM SUBI2
C-----------------------------------------------------------------------
C! Copies subimage that overlaps with image2 to output image
C# Task MAP-UTIL AP OOP
C   This software is the subject of a User agreement and is confidential
C   in nature. It shall not be sold or otherwise made available or
C   disclosed to third parties.
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      CHARACTER PRGM*6, IN*32, IN2*32, OUT*32
      INTEGER  IERR, BUFF1(256)
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA PRGM /'SUBI2 '/
C-----------------------------------------------------------------------
C                                       Startup
      CALL SUB2IN (PRGM, IN, IN2, OUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Do the action
      CALL SUB2AB (IN, IN2, OUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       History
      CALL SUB2HI (IN, OUT)
C                                       Close down files, etc.
 990  CALL DIE (IERR, BUFF1)
C
 999  STOP
      END

      SUBROUTINE SUB2IN (PRGN, IN, IN2, OUT, IERR)
C-----------------------------------------------------------------------
C   SUB2IN gets input parameters for SUBI2 and creates the output.
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IN      C*?  Input object (image to be copied)
C      IN2     C*?  Input object 2 (reference image)
C      OUT     C*?  Output object, only name filled in.
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER PRGN*6, IN*(*), IN2*(*), OUT*(*)
C
      INCLUDE 'INCS:PUVD.INC'
      INTEGER   NKEY1, NKEY2, NKEY3
C                                       NKEY1=no. adverbs for IN
      PARAMETER (NKEY1=4)
C                                       NKEY2=no. adverbs for IN2
      PARAMETER (NKEY2=4)
C                                       NKEY3 = no. adverb for OUT
      PARAMETER (NKEY3=4)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32, INK2(NKEY2)*8,
     *   OUTK2(NKEY2)*32, INK3(NKEY3)*8, OUTK3(NKEY3)*32
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs for IN
C                    1          2        3        4
      DATA INK1 /'INNAME', 'INCLASS', 'INSEQ', 'INDISK'/
C                                       Rename
C                    1       2       3        4
      DATA OUTK1 /'NAME', 'CLASS', 'IMSEQ', 'DISK'/
C                                       Adverbs for IN2
C                    1          2        3        4
      DATA INK2 /'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK'/
C                                       Rename
C                    1       2       3        4
      DATA OUTK2 /'NAME', 'CLASS', 'IMSEQ', 'DISK'/
C                                       Adverbs for OUT
C                    1          2          3          4
      DATA INK3 /'OUTNAME', 'OUTCLASS', 'OUTSEQ', 'OUTDISK'/
C                                       Rename
C                   1       2         3       4
      DATA OUTK3 /'NAME', 'CLASS', 'IMSEQ', 'DISK'/
C-----------------------------------------------------------------------
C                                       Startup
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Create IN
      IN = 'Input image object'
      CALL CREATE (IN, 'IMAGE', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, IN, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open and close to check that
C                                       it's OK
      CALL OOPEN (IN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OCLOSE (IN, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Create IN2
      IN2 = 'Input reference image object'
      CALL CREATE (IN2, 'IMAGE', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY2, INK2, OUTK2, IN2, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Open and close to check that
C                                       it's OK
      CALL OOPEN (IN2, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OCLOSE (IN2, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Create output object
      OUT = 'Output image'
      CALL CREATE (OUT, 'IMAGE', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY3, INK3, OUTK3, OUT, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END

      SUBROUTINE SUB2HI (IN, OUT)
C-----------------------------------------------------------------------
C   Routine to write history file to output.
C   Inputs:
C      IN      C*?  Input object
C      OUT     C*?  Output object
C-----------------------------------------------------------------------
      CHARACTER IN*(*), OUT*(*)
C
      INTEGER   NADV
      PARAMETER (NADV=8)
      CHARACTER LIST(NADV)*8
      INTEGER   IERR
      INCLUDE 'INCS:DMSG.INC'
C                                       Adverbs to copy to history
      DATA LIST /'INNAME',  'INCLASS',  'INSEQ',  'INDISK',
     *           'IN2NAME', 'IN2CLASS', 'IN2SEQ', 'IN2DISK'/
C-----------------------------------------------------------------------
C                                        Copy old history
      CALL OHCOPY (IN, OUT, IERR)
      IF (IERR.NE.0) GO TO 990
C                                        New additions - copy adverb
C                                        values.
      CALL OHLIST ('Input', LIST, NADV, OUT, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // OUT
      CALL MSGWRT (6)
 999  RETURN
      END

      SUBROUTINE SUB2AB (IN, IN2, OUT, IERR)
C-----------------------------------------------------------------------
C   Copy subimage of IN that overlaps with IN2 to OUT
C   Inputs:
C      IN      C*   Name of input image object.
C      IN2     C*   Name of input reference image object.
C      OUT     C*   Name of output image object.
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER IN*(*), IN2*(*), OUT*(*)
C
      INTEGER   J, TYPE, DIM(7), NAXIS(7), NAXIS2(7), NX, NY
      REAL    XYZI(7), XYZO(7), X1, X2, Y1, Y2, DUMMY
      INTEGER BLC(7), TRC(7), IROUND
      CHARACTER CDUMMY*1, OUTNAM*12, INNAM*12, OUTCL*6, INCL*6
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
      DATA XYZI/7*1.0/, BLC/7*0/, TRC/7*0/
C-----------------------------------------------------------------------
C                                       Open input objects
      CALL OOPEN (IN, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OOPEN (IN2, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get input image dimensions
      CALL OGET (IN, 'ARRAY.ARRAY_DESC.NAXIS', TYPE, DIM,
     *   NAXIS, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (IN2, 'ARRAY.ARRAY_DESC.NAXIS', TYPE, DIM,
     *   NAXIS2, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Go around edge of reference image
C                                       checking how pixel positions map
C                                       into input image.  Save extremes.
      NX = NAXIS2(1)
      NY = NAXIS2(2)
      X1 = NAXIS(1)
      X2 = 1.0
      Y1 = NAXIS(2)
      Y2 = 1.0
      DO 10 J=1,10
         XYZI(1) = 1.0 + NX*(J-1)/10
         XYZI(2) = 1.0
         CALL PSNCVT(IN2, XYZI, IN, XYZO, IERR)
         IF (IERR.NE.0) GO TO 999
         X1 = MIN(X1, XYZO(1))
         X2 = MAX(X2, XYZO(1))
         Y1 = MIN(Y1, XYZO(2))
         Y2 = MAX(Y2, XYZO(2))
         XYZI(1) = NX*J/10
         XYZI(2) = NY
         CALL PSNCVT(IN2, XYZI, IN, XYZO, IERR)
         IF (IERR.NE.0) GO TO 999
         X1 = MIN(X1, XYZO(1))
         X2 = MAX(X2, XYZO(1))
         Y1 = MIN(Y1, XYZO(2))
         Y2 = MAX(Y2, XYZO(2))
         XYZI(1) = 1.0
         XYZI(1) = NY*J/10
         CALL PSNCVT(IN2, XYZI, IN, XYZO, IERR)
         IF (IERR.NE.0) GO TO 999
         X1 = MIN(X1, XYZO(1))
         X2 = MAX(X2, XYZO(1))
         Y1 = MIN(Y1, XYZO(2))
         Y2 = MAX(Y2, XYZO(2))
         XYZI(1) = NX
         XYZI(1) = 1.0 + NY*(J-1)/10
         CALL PSNCVT(IN2, XYZI, IN, XYZO, IERR)
         IF (IERR.NE.0) GO TO 999
         X1 = MIN(X1, XYZO(1))
         X2 = MAX(X2, XYZO(1))
         Y1 = MIN(Y1, XYZO(2))
         Y2 = MAX(Y2, XYZO(2))
  10  CONTINUE
C                                       Add 10 pixels on all sides
C                                       and trim to fit in input image
      X1 = MIN( MAX(X1-10,1.0), FLOAT(NAXIS(1)) )
      X2 = MIN( MAX(X2+10,1.0), FLOAT(NAXIS(1)) )
      Y1 = MIN( MAX(Y1-10,1.0), FLOAT(NAXIS(2)) )
      Y2 = MIN( MAX(Y2+10,1.0), FLOAT(NAXIS(2)) )
C                                       Close input objects
      CALL OCLOSE (IN, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OCLOSE (IN2, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Set BLC, TRC for input image
      CALL OGET (IN, 'ARRAY.ARRAY_DESC.BLC', TYPE, DIM,
     *   BLC, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (IN, 'ARRAY.ARRAY_DESC.TRC', TYPE, DIM,
     *   TRC, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      BLC(1) = IROUND(X1)
      BLC(2) = IROUND(Y1)
      TRC(1) = IROUND(X2)
      TRC(2) = IROUND(Y2)
      WRITE (MSGTXT, 1001) BLC(1),BLC(2),TRC(1),TRC(2)
      CALL MSGWRT (1)
      CALL OPUT (IN, 'ARRAY.ARRAY_DESC.BLC', TYPE, DIM,
     *   BLC, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OPUT (IN, 'ARRAY.ARRAY_DESC.TRC', TYPE, DIM,
     *   TRC, CDUMMY, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Fix blank name, class for output
      CALL OGET (OUT, 'NAME', TYPE, DIM, DUMMY, OUTNAM, IERR)
      IF (IERR.NE.0) GO TO 999
      IF (OUTNAM.EQ.' ') THEN
         CALL OGET (IN, 'NAME', TYPE, DIM, DUMMY, INNAM, IERR)
         IF (IERR.NE.0) GO TO 999
         CALL OPUT (OUT, 'NAME', TYPE, DIM, DUMMY, INNAM, IERR)
         IF (IERR.NE.0) GO TO 999
      ENDIF
C
      CALL OGET (OUT, 'CLASS', TYPE, DIM, DUMMY, OUTCL, IERR)
      IF (IERR.NE.0) GO TO 999
      IF (OUTCL.EQ.' ') THEN
         CALL OPUT (OUT, 'CLASS', TYPE, DIM, DUMMY, 'SUBI2 ', IERR)
         IF (IERR.NE.0) GO TO 999
      ENDIF
C                                       Copy subimage to output
      CALL IMCOPY (IN, OUT, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
1001  FORMAT ('Copying subimage with BLC=',I5,I5,' TRC=',I5,I5)
      END
