LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER NPARMS
C                                       NPARMS=no. adverbs passed.
C USERID     User number.
C INNAME     Main input file (name).
C INCLASS    Main input file (class).
C INSEQ      Main input file (seq. #).
C INDISK     Disk unit #.       0 => any
C INVERS     Input  file version no.
C
      PARAMETER (NPARMS=6)
      INTEGER AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END

LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
C                                       Adverb names
C                      1        2         3          4        5
      DATA AVNAME /'USERID', 'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
C           6
     *   'INVER'/
C                                       Adverb data types (PAOOF.INC)
C                      1        2         3          4        5
      DATA AVTYPE /  OOAINT,  OOACAR,   OOACAR,    OOAINT,  OOAINT,
C           6
     *    OOAINT/
C                                       Adverb dimensions (as 2D)
C                      1        2         3          4        5
      DATA AVDIM /   1,1,    12,1,      6,1,       1,1,     1,1,
C           6
     *    1,1/
LOCAL END

      PROGRAM UNANN
C-----------------------------------------------------------------------
C! Change map scale to correct for annual aberration
C# Utility OOP
C   This software is the subject of a User agreement and is confidential
C   in nature. It shall not be sold or otherwise made available or
C   disclosed to third parties.
C-----------------------------------------------------------------------
      INTEGER  IERR, BUFF1(256)
      INTEGER NHIST, NHMAX
      PARAMETER (NHMAX = 20)
      CHARACTER PRGM*6, INOBJ*32, OUTOBJ*32, MYHIST(NHMAX)*72
      DATA PRGM /'UNANN '/, NHIST /0/
C-----------------------------------------------------------------------
C                                       Startup
      CALL UNANIN (PRGM, INOBJ, OUTOBJ, IERR)
C                                       Do action
      IF (IERR.EQ.0) CALL UNANAB (INOBJ, OUTOBJ, MYHIST, NHMAX,
     *   NHIST, IERR)
C                                       History
      IF (IERR.EQ.0) CALL UNANHI (OUTOBJ, MYHIST, NHIST)
C                                       Close down files, etc.
 990  CALL DIE (IERR, BUFF1)
C
 999  STOP
      END

      SUBROUTINE UNANIN (PRGN, INOBJ, OUTOBJ, IERR)
C-----------------------------------------------------------------------
C   UNANIN gets input parameters for UNANN and creates the input and
C   output object.
C
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      INOBJ   C*32 Input object name
C      OUTOBJ  C*32 Output object name
C      IERR    I    Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER PRGN*6, INOBJ*32, OUTOBJ*32
C
      INTEGER   NKEY1
C                                       NKEY1=no. adverbs to copy to INOBJ
      PARAMETER (NKEY1=6)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs to copy to INOBJ
C                      1        2         3          4        5
      DATA INK1   /'USERID', 'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
C           6
     *   'INVER'/
C                                       May rename adverbs to INOBJ
C                      1        2         3          4        5
      DATA OUTK1  /'USERID', 'NAME',   'CLASS',   'IMSEQ',   'DISK',
C           6
     *   'VER'/
C
C-----------------------------------------------------------------------
C                                       Startup,  returns "Input" object
C                                       containing POPS adverbs
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Create input object
      INOBJ = 'Input object'
      CALL CREATE (INOBJ, 'IMAGE', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, INOBJ, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Shallow copy image for write
      OUTOBJ = 'Shallow copy'
      CALL OCOPY (INOBJ, OUTOBJ, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END

      SUBROUTINE UNANHI (OUTOBJ, MYHIST, NHIST)
C-----------------------------------------------------------------------
C   Routine to write history file to output object.  This assumes
C   that a previous history exists and merely adds the information from
C   the current task.
C
C   If NHIST=0 then no history records are written.
C
C   Inputs:
C      OUTOBJ  C*?  Output object
C      MYHIST  C*72 Array (NHIST) of extra history lines
C-----------------------------------------------------------------------
      INTEGER NHIST
      CHARACTER OUTOBJ*(*), MYHIST(NHIST)*72
C
      INTEGER   NADV, I
      PARAMETER (NADV=4)
      CHARACTER LIST(NADV)*8
      INTEGER   IERR
      INCLUDE 'INCS:DMSG.INC'
C                                       Adverbs to copy to history
      DATA LIST /'INNAME', 'INCLASS', 'INSEQ', 'INVER'/
C-----------------------------------------------------------------------
C
      IF (NHIST.EQ.0) RETURN
C                                       Add task label to history
      CALL OHTIME (OUTOBJ, IERR)
      IF (IERR.NE.0) GO TO 990
C                                       Copy adverb values.
      CALL OHLIST ('Input', LIST, NADV, OUTOBJ, IERR)
      IF (IERR.NE.0) GO TO 990
C
C                                       Add info on results.
      DO 10 I=1,NHIST
         CALL OHWRIT(MYHIST(I), OUTOBJ, IERR)
         IF (IERR.NE.0) GO TO 990
  10  CONTINUE
C
      CALL OCLOSE (OUTOBJ, IERR)
      IF (IERR.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  MSGTXT = 'ERROR WRITING HISTORY FOR ' // OUTOBJ
      CALL MSGWRT (4)
 999  RETURN
      END

      SUBROUTINE UNANAB (INOBJ, OUTOBJ, MYHIST, NHMAX, NHIST, IERR)
C-----------------------------------------------------------------------
C   Restore pixel size in header from ANNABCD keyword.
C   Inputs:
C      INOBJ   C*   Name of input object.
C      NHMAX   I    Maximum number of history lines to write.
C   Output:
C      MYHIST  C*72 History lines.
C      NHIST   I    Number of history lines written.
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   NHMAX, NHIST, IERR
      CHARACTER INOBJ*(*), OUTOBJ*(*), MYHIST(NHMAX)*72
C
C
      INTEGER   TYPE, DIM(7), DIM2(7), I, MSGSAV, KILSAV
      REAL      CDELT(7), CDELT2(2)
      CHARACTER CDUMMY*1
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C                                       Open input & output objects
      CALL OOPEN (INOBJ, 'READ', IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OOPEN (OUTOBJ, 'WRIT', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Make new header keywords
      CALL OBVHKW ('IMAGE   ', 'ANNABCOR', OOALOG, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBVHKW ('IMAGE   ', 'ANNABCD1', OOARE, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OBVHKW ('IMAGE   ', 'ANNABCD2', OOARE, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Check whether correction already done
C                                       Suppress warning messages.
      MSGSAV = MSGSUP
      KILSAV = MSGKIL
      MSGSUP = 32000
      MSGKIL = 32007
      CALL OGET (INOBJ, 'ANNABCOR', TYPE, DIM, I, CDUMMY, IERR)
      MSGSUP = MSGSAV
      MSGKIL = KILSAV
      IF (IERR.NE.0) THEN
C                                       No correction has been done
         IERR = 0
         TYPE = OOALOG
         I = 0
      ENDIF
C
      IF (TYPE .NE. OOALOG) THEN
C                                       Keyword is present but is not logical!
         WRITE (MSGTXT, 1001)
     *      'Keyword ANNABCOR is not of type logical!'
         CALL MSGWRT (4)
         IERR = 1
         GO TO 999
      ELSE IF (I .EQ. 0) THEN
C                                       No correction has been done
         WRITE (MSGTXT, 1001)
     * 'Warning: ANNAB not applied to this image; no action taken.'
         CALL MSGWRT (1)
C                                       Close input image
         CALL OCLOSE (INOBJ, IERR)
         IF (IERR.NE.0) GO TO 999
C                                       Close output image
         CALL OCLOSE (OUTOBJ, IERR)
         IF (IERR.NE.0) GO TO 999
         GO TO 999
      ENDIF
C
C                                       Get current pixel sizes
      CALL OGET (INOBJ, 'IMAGE_DESC.CDELT', TYPE, DIM, CDELT, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Get old pixel sizes
      CALL OGET (INOBJ, 'ANNABCD1', TYPE, DIM2, CDELT2(1), CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INOBJ, 'ANNABCD2', TYPE, DIM2, CDELT2(2), CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C
C                                       Restore pixel sizes
      CDELT(1) = CDELT2(1)
      CDELT(2) = CDELT2(2)
      CALL OPUT (OUTOBJ, 'IMAGE_DESC.CDELT', TYPE, DIM, CDELT, CDUMMY,
     *   IERR)
      IF (IERR.NE.0) GO TO 999
C
C                                       Set ANNABCOR keyword to F
      I = 0
      CALL PUTKEY (OUTOBJ, 'ANNABCOR', OOALOG, I, I, IERR)
      IF (IERR.NE.0) GO TO 999
C
C                                       History
      IF (NHIST.LT.NHMAX) THEN
         NHIST = NHIST+1
         WRITE(MYHIST(NHIST),1001) 'Restored pixels to original sizes'
      ENDIF
C
C                                       Close input image
      CALL OCLOSE (INOBJ, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Close output image
      CALL OCLOSE (OUTOBJ, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
C-----------------------------------------------------------------------
1001  FORMAT (A)
      END
