LOCAL INCLUDE 'INPUT.INC'
C                                       Declarations for inputs
      INTEGER NPARMS
C                                       NPARMS=no. adverbs passed.
C USERID     User number.
C INNAME     Main input file (name).
C INCLASS    Main input file (class).
C INSEQ      Main input file (seq. #).
C INDISK     Disk unit #.       0 => any
C INVERS     Input  file version no.
C
      PARAMETER (NPARMS=6)
      INTEGER AVTYPE(NPARMS), AVDIM(2,NPARMS)
      CHARACTER AVNAME(NPARMS)*8
LOCAL END

LOCAL INCLUDE 'INPUTDATA.INC'
C                                       DATA statments defining input
C                                       parameters.
C                                       Adverb names
C                      1        2         3          4        5
      DATA AVNAME /'USERID', 'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
C           6
     *   'INVER'/
C                                       Adverb data types (PAOOF.INC)
C                      1        2         3          4        5
      DATA AVTYPE /  OOAINT,  OOACAR,   OOACAR,    OOAINT,  OOAINT,
C           6
     *    OOAINT/
C                                       Adverb dimensions (as 2D)
C                      1        2         3          4        5
      DATA AVDIM /   1,1,    12,1,      6,1,       1,1,     1,1,
C           6
     *    1,1/
LOCAL END

      PROGRAM VTEST
C-----------------------------------------------------------------------
C! Print message telling whether file exists or not
C# Utility OOP
C   This software is the subject of a User agreement and is confidential
C   in nature. It shall not be sold or otherwise made available or
C   disclosed to third parties.
C-----------------------------------------------------------------------
      INTEGER  IERR, BUFF1(256)
      CHARACTER PRGM*6, INOBJ*32
      DATA PRGM /'VTEST '/
C-----------------------------------------------------------------------
C                                       Startup
      CALL VTSTIN (PRGM, INOBJ, IERR)
C                                       Do action
      IF (IERR.EQ.0) CALL VTSTAB (INOBJ, IERR)
C                                       Close down files, etc.
 990  CALL DIE (IERR, BUFF1)
C
 999  STOP
      END

      SUBROUTINE VTSTIN (PRGN, INOBJ, IERR)
C-----------------------------------------------------------------------
C   VTSTIN gets input parameters for VTEST and creates the input object.
C
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      INOBJ   C*32 Input object name
C      IERR    I    Error code: 0 => ok
C                               4 => user routine detected error.
C                               5 => catalog troubles
C                               8 => can't start
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER PRGN*6, INOBJ*32
C
      INTEGER   NKEY1
C                                       NKEY1=no. adverbs to copy to INOBJ
      PARAMETER (NKEY1=6)
      CHARACTER INK1(NKEY1)*8, OUTK1(NKEY1)*32
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INPUT.INC'
      INCLUDE 'INPUTDATA.INC'
C                                       Adverbs to copy to INOBJ
C                      1        2         3          4        5
      DATA INK1   /'USERID', 'INNAME', 'INCLASS', 'INSEQ', 'INDISK',
C           6
     *   'INVER'/
C                                       May rename adverbs to INOBJ
C                      1        2         3          4        5
      DATA OUTK1  /'USERID', 'NAME',   'CLASS',   'IMSEQ',   'DISK',
C           6
     *   'VER'/
C
C-----------------------------------------------------------------------
C                                       Startup,  returns "Input" object
C                                       containing POPS adverbs
      CALL AV2INP (PRGN, NPARMS, AVNAME, AVTYPE, AVDIM, 'Input', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Create input object
      INOBJ = 'Input object'
      CALL CREATE (INOBJ, 'IMAGE', IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Copy adverbs to object
      CALL IN2OBJ ('Input', NKEY1, INK1, OUTK1, INOBJ, IERR)
      IF (IERR.NE.0) GO TO 999
C
 999  RETURN
      END

      SUBROUTINE VTSTAB (INOBJ, IERR)
C-----------------------------------------------------------------------
C   Check file for existence
C   Inputs:
C      INOBJ   C*   Name of input object.
C   Output:
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      INTEGER   IERR
      CHARACTER INOBJ*(*)
C
      LOGICAL   EXTOBJ
      INCLUDE 'INCS:DMSG.INC'
C
      IF (EXTOBJ(INOBJ)) THEN
         WRITE (MSGTXT, 1001) 'File exists'
      ELSE
         WRITE (MSGTXT, 1001) 'File does not exist'
      ENDIF
      CALL MSGWRT(1)
      IERR = 0
 999  RETURN
C-----------------------------------------------------------------------
1001  FORMAT (A)
      END
