      SUBROUTINE DC2DMS(DEC, SDIG, DCSIGN, DD, MM, SS, IERR)
C-----------------------------------------------------------------------
C   Convert Dec in degrees to degrees, minutes, seconds.  Rounded so that
C   it can be printed using SS.SSS... format, where there are SDIG
C   digits after the decimal point in the seconds.
C   Inputs:
C      DEC     D    Declination in degrees
C      SDIG    I    Number of digits past decimal point in seconds
C   Outputs:
C      DCSIGN  C*1  Sign
C      DD      I    Hours
C      MM      I    Minutes
C      SS      R    Seconds
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      DOUBLE PRECISION    DEC
      CHARACTER*1 DCSIGN
      INTEGER   SDIG, DD, MM, IERR
      REAL      SS
C
      DOUBLE PRECISION DECD
C-----------------------------------------------------------------------
      IF (DEC .GE. 0.0) THEN
         DCSIGN = '+'
         DECD = DEC
      ELSE
         DCSIGN = '-'
         DECD = -DEC
      ENDIF
      DD = DECD
      MM = (DECD - DD) * 60.0
      SS = ( (DECD - DD) * 60.0 - MM) * 60.0
C
C Round so that we don't get values like 01 60 60.0 when printed
C with SDIG digits past decimal point in seconds
C
      IF (SS .GT. 60.0 - 0.5 * 10.0**(-SDIG) ) THEN
         SS = 0.0
         MM = MM+1
         IF (MM .GE. 60) THEN
            MM = MM - 60
            DD = DD + 1
         ENDIF
      ENDIF
      IERR = 0
999   RETURN
      END
