      REAL FUNCTION GCIRCL(RA1,DEC1,RA2,DEC2)
C
C Compute great circle distance in degrees between 2 positions
C (also in degrees)
C
      DOUBLE PRECISION RA1, DEC1, RA2, DEC2
C
      DOUBLE PRECISION PI, D2R, ARG
      PARAMETER (PI = 3.14159265358979324)
C
      D2R = PI/180.0D0
C Modified 1998 Nov 16 to handle very rare round-off problem
      ARG = SIN(D2R*DEC1) * SIN(D2R*DEC2) +
     *   COS(D2R*DEC1) * COS(D2R*DEC2) * COS(D2R*(RA2-RA1))
      IF (ARG.GT.1) THEN
         ARG = 1.0
      ELSE IF (ARG.LT.-1) THEN
         ARG = -1.0
      ENDIF
      GCIRCL = ACOS(ARG) / D2R
      RETURN
      END
