      SUBROUTINE GETEQN(INPUT, IEQUNX, IERR)
C-----------------------------------------------------------------------
C   Get equinox for map
C   Inputs:
C      INPUT   C*   Name of input image object.
C   Outputs:
C      IEQUNX  I    Equinox (1950 or 2000)
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER INPUT*(*)
      INTEGER   IEQUNX, IERR
C
      REAL EQUINX
      INTEGER TYPE, DIM(7)
C
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
C      CALL OGET (INPUT,'IMAGE_DESC.EPOCH',TYPE,DIM,EQUINX,EQUINX,IERR)
      CALL OGET (INPUT,'EPOCH',TYPE,DIM,EQUINX,EQUINX,IERR)
      IF (IERR.NE.0) GO TO 999
C
C Check to make sure it is 1950 or 2000
C
      IF (EQUINX.NE.1950.0 .AND. EQUINX.NE.2000.0) THEN
         WRITE(MSGTXT,1000) EQUINX,INPUT
         CALL MSGWRT(1)
      ENDIF
      IEQUNX = INT(EQUINX+0.5)
C
 999  CONTINUE
      RETURN
C
1000  FORMAT('WARNING: Equinox =',F8.1,' is not 1950 or 2000 for ',A)
      END
