      SUBROUTINE GETFRQ(INPUT, FREQ, IERR)
C-----------------------------------------------------------------------
C   Get frequency for object.
C   Inputs:
C      INPUT   C*   Name of input image object.
C   Outputs:
C      FREQ    R    Frequency (Hz)
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER INPUT*(*)
      REAL      FREQ
      INTEGER   IERR
C
      INTEGER TYPE, DIM(7), I
      DOUBLE PRECISION CRVAL(7)
      CHARACTER*8 CTYPE(7)
      CHARACTER*56 CLONG
      EQUIVALENCE (CTYPE, CLONG)
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 0
C Get type for each axis
      CALL OGET (INPUT, 'IMAGE_DESC.CTYPE', TYPE, DIM,
     *   CLONG, CLONG, IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INPUT, 'IMAGE_DESC.CRVAL', TYPE, DIM,
     *   CRVAL, CRVAL, IERR)
      IF (IERR.NE.0) GO TO 990
C
C Look for 'FREQ'
      DO 10 I=1,7
         IF (CTYPE(I).EQ.'FREQ    ') THEN
C This is it, get the value
            FREQ = CRVAL(I)
            IF (FREQ.LT. 0.2E9 .OR. FREQ.GT.2.E10) THEN
               WRITE (MSGTXT,1000) 'WARNING: Frequency=',FREQ,' ?'
               CALL MSGWRT (1)
            ENDIF
            GO TO 999
         ENDIF
  10  CONTINUE
C
 990  CONTINUE
      IERR = 1
      MSGTXT = 'Unable to get frequency for observation'
      CALL MSGWRT (6)
C
 999  RETURN
1000  FORMAT(A,E13.5,A)
      END
