      SUBROUTINE GETPOS(INPUT, RACEN, DECEN, XSHIFT, YSHIFT, IERR)
C-----------------------------------------------------------------------
C   Get RA and Dec for phase center of map
C   Inputs:
C      INPUT   C*   Name of input image object.
C   Outputs:
C      RACEN   D    RA phase center (degrees)
C      DECEN   D    Dec phase center (degrees)
C      XSHIFT  R    X shift from phase center (degrees)
C      YSHIFT  R    Y shift from phase center (degrees)
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER INPUT*(*)
      DOUBLE PRECISION    RACEN, DECEN
      INTEGER   IERR
C
      INTEGER TYPE, DIM(7)
      REAL XSHIFT, YSHIFT
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      CALL OGET (INPUT, 'POSITION.OBSRA', TYPE,DIM,RACEN,RACEN,IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INPUT, 'POSITION.OBSDEC', TYPE,DIM,DECEN,DECEN,IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INPUT, 'POSITION.XSHIFT', TYPE,DIM,XSHIFT,XSHIFT,IERR)
      IF (IERR.NE.0) GO TO 999
      CALL OGET (INPUT, 'POSITION.YSHIFT', TYPE,DIM,YSHIFT,YSHIFT,IERR)
      IF (IERR.NE.0) GO TO 999
C
C No need to apply shift because CC list gives coordinates relative
C to phase center
C
C      RACEN = RACEN + XSHIFT
C      DECEN = DECEN + YSHIFT
C
 999  RETURN
      END
