      SUBROUTINE INDEXX(N,RA,RB,RC,INDX,COMPFN)
C Numerical Recipes heapsort, producing an index array
C COMPFN compares 2 triplets and returns true if the first is
C better than the second.
C RA, RB, and RC are not changed.  INDX contains an index array on output.
      INTEGER N
      INTEGER INDX(N)
      REAL RA(N),RB(N),RC(N)
      LOGICAL COMPFN
C
      REAL RRA, RRB, RRC
      INTEGER I, J, L, IR, INDXT
C
      DO 5 J=1,N
         INDX(J)=J
5     CONTINUE
      IF (N.LE.1) RETURN
      L=N/2+1
      IR=N
10    CONTINUE
         IF(L.GT.1)THEN
            L=L-1
            INDXT=INDX(L)
            RRA=RA(INDXT)
            RRB=RB(INDXT)
            RRC=RC(INDXT)
         ELSE
            INDXT=INDX(IR)
            RRA=RA(INDXT)
            RRB=RB(INDXT)
            RRC=RC(INDXT)
            INDX(IR)=INDX(1)
            IR=IR-1
            IF(IR.EQ.1)THEN
               INDX(1)=INDXT
               RETURN
            ENDIF
         ENDIF
         I=L
         J=L+L
20       IF(J.LE.IR)THEN
            IF(J.LT.IR)THEN
               IF(COMPFN(RA(INDX(J)), RB(INDX(J)), RC(INDX(J)),
     *            RA(INDX(J+1)), RB(INDX(J+1)), RC(INDX(J+1)))) J=J+1
            ENDIF
            IF(COMPFN(RRA, RRB, RRC, RA(INDX(J)), RB(INDX(J)),
     *        RC(INDX(J)))) THEN
               INDX(I)=INDX(J)
               I=J
               J=J+J
            ELSE
               J=IR+1
            ENDIF
         GO TO 20
         ENDIF
         INDX(I)=INDXT
      GO TO 10
      END
