      SUBROUTINE GETEPC(INPUT, JEPOCH, IERR)
C-----------------------------------------------------------------------
C   Get epoch for map
C   Inputs:
C      INPUT   C*   Name of input image object.
C   Outputs:
C      JEPOCH  R    Equinox (e.g. 1993.35)
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      CHARACTER INPUT*(*)
      REAL      JEPOCH
      INTEGER   IERR
C
      CHARACTER CDATE*8
      INTEGER TYPE, DIM(7), MM, DD, YY, OFFSET(12), DOFY
C
      INCLUDE 'INCS:DMSG.INC'
C
C OFFSET is cumulative number of days to first of each month
      DATA OFFSET/0, 31, 59, 90, 120, 151, 182, 212, 243, 273,
     *   304, 334/
C-----------------------------------------------------------------------
      CALL OGET (INPUT,'IMAGE_DESC.DATE-OBS',TYPE,DIM,CDATE,CDATE,IERR)
      IF (IERR.NE.0) GO TO 999
C
C Convert string to epoch
C
      IF (CDATE(3:3) .NE. '/' .OR. CDATE(6:6) .NE. '/') THEN
         WRITE(MSGTXT,1000) CDATE
         CALL MSGWRT (4)
         GO TO 999
      ENDIF
C
      READ (CDATE, 1001) DD, MM, YY
C
      IF (YY .LT. 50) THEN
C Year is apparently greater than 2000
         YY = YY+2000
      ELSE
C Year is apparently less than 2000
         YY = YY+1900
      ENDIF
C
      DOFY = OFFSET(MM) + DD
      IF (MOD(YY, 4) .EQ. 0) THEN
C a leap year
         IF (MM .GE. 3) DOFY = DOFY+1
         JEPOCH = YY + (DOFY-0.5)/366.0
      ELSE
         JEPOCH = YY + (DOFY-0.5)/365.0
      ENDIF
C
 999  CONTINUE
      RETURN
C
1000  FORMAT('Format of DATE-OBS is illegal: "',A,'"')
1001  FORMAT(I2,1X,I2,1X,I2)
      END
