C  Put a keyword to catalog header
C-----------------------------------------------------------------------
C! Put a keyword to catalog header
C# Utility OOP
C   This software is the subject of a User agreement and is confidential
C   in nature. It shall not be sold or otherwise made available or
C   disclosed to third parties.
C-----------------------------------------------------------------------
      SUBROUTINE PUTKEY (NAME, KEYWRD, TYPE, VALUE, VALUEC, IERR)
C-----------------------------------------------------------------------
C   Put a keyword to catalog header.  This should change when new version
C   of AIPS has the OBVHKW routine (which asserts that a virtual keyword
C   is to be a catalog header keyword.)  Then it should be possible just
C   to call OBVHKW followed by OPUT or OBPUT.
C
C   This version works (?) under the 15OCT92 version of AIPS.
C
C   Inputs:
C      NAME     C*?   The name of the object.
C      KEYWRD   C*?   The keyword name (<= 8 characters)
C      TYPE     I     Data type: 1=D, 2=R, 3=C, 4=I, 5=L
C      VALUE    ?     The value associated with keyword (numeric).
C      VALUEC   C*?   Associated value (character)
C   Outputs:
C      IERR     I     Error return code, 0=OK
C-----------------------------------------------------------------------
      CHARACTER NAME*(*), KEYWRD*(*), VALUEC*(*)
      INTEGER   TYPE, VALUE, IERR
C
      INTEGER   DISK, CNO
      HOLLERITH HTEMP(2)
      CHARACTER*8 KEY8
C
      INCLUDE 'INCS:OBJPARM.INC'
      INCLUDE 'INCS:CLASSIO.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      IERR = 0
C                                       Get DISK and CNO number.
      CALL OBDSKC (NAME, DISK, CNO, IERR)
      IF (IERR.NE.0) GO TO 999
C                                       Write keyword/value in header
      KEY8 = KEYWRD
      IF (TYPE.NE.3) THEN
C                                       Non-character
         CALL CATKEY ('WRIT', DISK, CNO, KEY8, 1, 1, VALUE,
     *      TYPE, SBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
      ELSE
C                                       Character
         CALL CHR2H (8, VALUEC, 1, HTEMP)
         CALL CATKEY ('WRIT', DISK, CNO, KEY8, 1, 1, HTEMP,
     *      TYPE, SBUFF, IERR)
         IF (IERR.NE.0) GO TO 999
      END IF
      GO TO 999
C                                       Error
 990  CALL MSGWRT (6)
      MSGTXT = 'Error writing catalog keyword ' // KEY8
      CALL MSGWRT (6)
C
 999  RETURN
      END
