      SUBROUTINE RA2HMS(RA, SDIG, HH, MM, SS, IERR)
C-----------------------------------------------------------------------
C   Convert RA in degrees to hrs, minutes, seconds.  Rounded so that
C   it can be printed using SS.SSS... format, where there are SDIG
C   digits after the decimal point in the seconds.
C   Inputs:
C      RA      D    RA in degrees
C      SDIG    I    Number of digits past decimal point in seconds
C   Outputs:
C      HH      I    Hours
C      MM      I    Minutes
C      SS      R    Seconds
C      IERR    I    Error code: 0 => ok
C-----------------------------------------------------------------------
      DOUBLE PRECISION    RA
      INTEGER   SDIG, HH, MM, IERR
      REAL      SS
C
      DOUBLE PRECISION RAH
C
      INCLUDE 'INCS:PAOOF.INC'
      INCLUDE 'INCS:DMSG.INC'
C-----------------------------------------------------------------------
      RAH = RA / 15.0
      IF (RAH.GE.24.0) RAH = RAH - 24.0
      IF (RAH.LT. 0.0) RAH = RAH + 24.0
      HH = RAH
      MM = (RAH - HH) * 60.0
      SS = ( (RAH - HH) * 60.0 - MM) * 60.0
C
C Round so that we don't get values like 01 60 60.0 when printed
C with SDIG digits past decimal point in seconds
C
      IF (SS .GT. 60.0 - 0.5 * 10.0**(-SDIG) ) THEN
         SS = 0.0
         MM = MM+1
         IF (MM .GE. 60) THEN
            MM = MM - 60
            HH = HH+1
            IF (HH .GE. 24) HH = HH-24
         ENDIF
      ENDIF
      IERR = 0
999   RETURN
      END
